package model

import hashPassword
import salt
import java.time.LocalDate

class AdminUser(
    userId: Int,
    login: String,
    password: String,
    email: String,
    lastAuthorizeDate: LocalDate,
): User(userId, login, password, email, lastAuthorizeDate), IAdminUser {

    override fun allUsers(authorizationList: MutableList<User>) {
        for (user in authorizationList) {
            println(user.login)
        }
    }

    override fun allUsersSort(authorizationList: MutableList<User>) {
        authorizationList.sortByDescending { it.lastAuthorizeDate }
        for (user in authorizationList) {
            println(user.login + " зашел в " + user.lastAuthorizeDate)
        }
    }

    override fun updateUserPassword(authorizationList: MutableList<User>) {
        println("Почту пиши для апдейта")
        val email = readln()
        println("Пароль пиши для апдейта")
        val password = readln()

        val user = authorizationList.find { it.email == email }
        require(user != null) {
            "нет такого"
        }

        user.password = hashPassword(password, salt)
    }

    override fun removeUser(authorizationList: MutableList<User>) {
        println("Почту пиши для апдейта")
        val email = readln()

        val removed = authorizationList.removeIf { it.email == email }
        if (removed) {
            println("удалили")
        } else { println("не удалили") }
    }
}